#!/bin/ksh
#Author: Wesley D. Jones
#Configuration script to setup database access after XCAT is installed

echo "Please wait..."

#Check to see if XCAT server software installed
rpm -qf /opt/xcat/sbin/xcatd > /dev/null 2>&1 
if [[ $? -ne 0 ]]
      then
        echo "XCAT not found.  Please install and try again..."
        exit 1
fi

# If XCAT installed first Setup symbolic links 
ln -sf /opt/isnm/cnm/db/ISNM.pm /opt/xcat/lib/perl/xCAT_schema/ISNM.pm

# Restart xcatd for table installation
service xcatd restart > /dev/null 2>&1

# load views, stored procedures, foreign keys
# Check DB type
cat /etc/xcat/cfgloc | grep -i db2 > /dev/null 2>&1
if [[ $? -eq 0 ]]
      then
        # DB type eq DB2
        /opt/xcat/sbin/runsqlcmd -f /opt/isnm/cnm/db/ISNM_db2.sql > /dev/null 2>&1
      else
        # DB type eq mysql
        /opt/xcat/sbin/runsqlcmd -f /opt/isnm/cnm/db/ISNM_mysql.sql > /dev/null 2>&1
fi

# insert default values into isnm_config table
/opt/xcat/sbin/chtab config_parm=PERF_DATA_INTERVAL isnm_config.config_value=300
/opt/xcat/sbin/chtab config_parm=PERF_DATA_SAVE_PERIOD isnm_config.config_value=168
/opt/xcat/sbin/chtab config_parm=NUM_PERF_DATA_SAVE_PERIOD isnm_config.config_value=1
/opt/xcat/sbin/chtab config_parm=MONITOR_RMC isnm_config.config_value=1
/opt/xcat/sbin/chtab config_parm=EXPIRED_PERIOD_TIMER isnm_config.config_value=3600
/opt/xcat/sbin/chtab config_parm=SUMMARY_DATA_TIMER isnm_config.config_value=43200
/opt/xcat/sbin/chtab config_parm=RECOV_POOL_INTERVAL isnm_config.config_value=300


exit 0
